<bugID>1311422<Summary>devtools leaks compartments in nightly 52</Summary><Description>Created attachment 8802567
memory-report.json.gz

The last few days I've noticed my nightly using large amounts of memory.  This slows the entire browser down due to large GC pauses.

The attached memory report is from a nightly 52.0a1 (2016-10-18) (64-bit).  Here I have shutdown all tabs except an example.com tab to keep the content process alive.  You can see that js-nonwindow is taking a ton of memory in the content process:

1,096.15 MB (100.0%) -- explicit
&#9500;&#9472;&#9472;&#9472;&#9472;674.16 MB (61.50%) -- js-non-window
&#9474;    &#9500;&#9472;&#9472;630.78 MB (57.55%) -- zones
&#9474;    &#9474;  &#9500;&#9472;&#9472;625.20 MB (57.04%) -- zone(0x25a3b2c3000)
&#9474;    &#9474;  &#9474;  &#9500;&#9472;&#9472;262.06 MB (23.91%) ++ compartment([System Principal], Addon-SDK (from: resource://gre/modules/commonjs/toolkit/loader.js:283))
&#9474;    &#9474;  &#9474;  &#9500;&#9472;&#9472;107.68 MB (09.82%) ++ shapes
&#9474;    &#9474;  &#9474;  &#9500;&#9472;&#9472;&#9472;81.86 MB (07.47%) ++ compartment([System Principal], resource://gre/modules/commonjs/toolkit/loader.js)
&#9474;    &#9474;  &#9474;  &#9500;&#9472;&#9472;&#9472;66.57 MB (06.07%) ++ scopes
&#9474;    &#9474;  &#9474;  &#9500;&#9472;&#9472;&#9472;44.73 MB (04.08%) ++ (139 tiny)
&#9474;    &#9474;  &#9474;  &#9500;&#9472;&#9472;&#9472;30.39 MB (02.77%) &#9472;&#9472; type-pool
&#9474;    &#9474;  &#9474;  &#9500;&#9472;&#9472;&#9472;19.25 MB (01.76%) ++ object-groups
&#9474;    &#9474;  &#9474;  &#9492;&#9472;&#9472;&#9472;12.65 MB (01.15%) ++ compartment([System Principal], [anonymous sandbox] (from: resource://gre/modules/commonjs/toolkit/loader.js -&gt; resource://devtools/shared/builtin-modules.js:185))
&#9474;    &#9474;  &#9492;&#9472;&#9472;&#9472;&#9472;5.58 MB (00.51%) ++ (3 tiny)
&#9474;    &#9500;&#9472;&#9472;&#9472;30.77 MB (02.81%) ++ runtime
&#9474;    &#9492;&#9472;&#9472;&#9472;12.61 MB (01.15%) ++ gc-heap
&#9500;&#9472;&#9472;&#9472;&#9472;312.10 MB (28.47%) -- heap-overhead
&#9474;    &#9500;&#9472;&#9472;289.48 MB (26.41%) &#9472;&#9472; bin-unused
&#9474;    &#9500;&#9472;&#9472;&#9472;21.72 MB (01.98%) &#9472;&#9472; bookkeeping
&#9474;    &#9492;&#9472;&#9472;&#9472;&#9472;0.90 MB (00.08%) &#9472;&#9472; page-cache
&#9500;&#9472;&#9472;&#9472;&#9472;&#9472;98.63 MB (09.00%) &#9472;&#9472; heap-unclassified
&#9492;&#9472;&#9472;&#9472;&#9472;&#9472;11.26 MB (01.03%) ++ (17 tiny)

This seems to be because there a ton of devtools compartments lying around:

1,865 (100.0%) -- js-main-runtime-compartments
&#9500;&#9472;&#9472;1,861 (99.79%) -- system
&#9474;  &#9500;&#9472;&#9472;&#9472;&#9472;430 (23.06%) &#9472;&#9472; [System Principal], Addon-SDK (from: resource://gre/modules/commonjs/toolkit/loader.js:283) [430]
&#9474;  &#9500;&#9472;&#9472;&#9472;&#9472;429 (23.00%) &#9472;&#9472; [System Principal], [anonymous sandbox] (from: resource://gre/modules/commonjs/toolkit/loader.js -&gt; resource://devtools/shared/builtin-modules.js:185) [429]
&#9474;  &#9500;&#9472;&#9472;&#9472;&#9472;429 (23.00%) &#9472;&#9472; [System Principal], [anonymous sandbox] (from: resource://gre/modules/commonjs/toolkit/loader.js -&gt; resource://devtools/shared/builtin-modules.js:209) [429]
&#9474;  &#9500;&#9472;&#9472;&#9472;&#9472;429 (23.00%) &#9472;&#9472; [System Principal], [anonymous sandbox] (from: resource://gre/modules/commonjs/toolkit/loader.js -&gt; resource://devtools/shared/builtin-modules.js:24) [429]
&#9474;  &#9492;&#9472;&#9472;&#9472;&#9472;144 (07.72%) ++ (130 tiny)
&#9492;&#9472;&#9472;&#9472;&#9472;&#9472;&#9472;4 (00.21%) ++ user

I've noticed that I can reliably cause these compartments to grow by doing the following:

1) Open about:debugging on the worker tab.  This leaks a few compartments.
2) Click the debug link on about:debugging to debug a worker.  This leaks many compartments.

Right now this issue is causing me to have to restart nightly every day or two.

Nick, any thoughts?</Description></bugID>